The Synthesis ToolKit in C++ (STK)

Home Information Classes Download Usage Mail List Requirements Links FAQ Tutorial

Public Member Functions | List of all members
stk::TwoPole Class Reference

STK two-pole filter class. More...

`#include <TwoPole.h>`

Inheritance diagram for stk::TwoPole:

## Public Member Functions
| TwoPole (void)
| Default constructor creates a second-order pass-through filter.
| ~TwoPole ()
| Class destructor.
void | ignoreSampleRateChange (bool ignore=true)
| A function to enable/disable the automatic updating of class data when the STK sample rate changes.
void | setB0 (StkFloat b0)
| Set the b[0] coefficient value.
void | setA1 (StkFloat a1)
| Set the a[1] coefficient value.
void | setA2 (StkFloat a2)
| Set the a[2] coefficient value.
void | setCoefficients (StkFloat b0, StkFloat a1, StkFloat a2, bool clearState=false)
| Set all filter coefficients.
void | setResonance (StkFloat frequency, StkFloat radius, bool normalize=false)
| Sets the filter coefficients for a resonance at frequency (in Hz). More...
StkFloat | lastOut (void) const
| Return the last computed output value.
StkFloat | tick (StkFloat input)
| Input one sample to the filter and return one output.
StkFrames & | tick (StkFrames &frames, unsigned int channel=0)
| Take a channel of the StkFrames object as inputs to the filter and replace with corresponding outputs. More...
StkFrames & | tick (StkFrames &iFrames, StkFrames &oFrames, unsigned int iChannel=0, unsigned int oChannel=0)
| Take a channel of the `iFrames` object as inputs to the filter and write outputs to the `oFrames` object. More...
Public Member Functions inherited from stk::Filter
| Filter (void)
| Class constructor.
unsigned int | channelsIn (void) const
| Return the number of input channels for the class.
unsigned int | channelsOut (void) const
| Return the number of output channels for the class.
virtual void | clear (void)
| Clears all internal states of the filter.
void | setGain (StkFloat gain)
| Set the filter gain. More...
StkFloat | getGain (void) const
| Return the current filter gain.
StkFloat | phaseDelay (StkFloat frequency)
| Return the filter phase delay at the specified frequency. More...
const StkFrames & | lastFrame (void) const
| Return an StkFrames reference to the last output sample frame.
Public Member Functions inherited from stk::Stk
void | ignoreSampleRateChange (bool ignore=true)
| A function to enable/disable the automatic updating of class data when the STK sample rate changes. More...

## Additional Inherited Members
Static Public Member Functions inherited from stk::Stk
static StkFloat | sampleRate (void)
| Static method that returns the current STK sample rate.
static void | setSampleRate (StkFloat rate)
| Static method that sets the STK sample rate. More...
static void | clear_alertList ()
| Static method that frees memory from alertList_.
static std::string | rawwavePath (void)
| Static method that returns the current rawwave path.
static void | setRawwavePath (std::string path)
| Static method that sets the STK rawwave path.
static void | swap16 (unsigned char *ptr)
| Static method that byte-swaps a 16-bit data type.
static void | swap32 (unsigned char *ptr)
| Static method that byte-swaps a 32-bit data type.
static void | swap64 (unsigned char *ptr)
| Static method that byte-swaps a 64-bit data type.
static void | sleep (unsigned long milliseconds)
| Static cross-platform method to sleep for a number of milliseconds.
static bool | inRange (StkFloat value, StkFloat min, StkFloat max)
| Static method to check whether a value is within a specified range.
static void | handleError (const char *message, StkError::Type type)
| Static function for error reporting and handling using c-strings.
static void | handleError (std::string message, StkError::Type type)
| Static function for error reporting and handling using c++ strings.
static void | showWarnings (bool status)
| Toggle display of WARNING and STATUS messages.
static void | printErrors (bool status)
| Toggle display of error messages before throwing exceptions.
Static Public Attributes inherited from stk::Stk
static const StkFormat | STK_SINT8
static const StkFormat | STK_SINT16
static const StkFormat | STK_SINT24
static const StkFormat | STK_SINT32
static const StkFormat | STK_FLOAT32
static const StkFormat | STK_FLOAT64
Protected Member Functions inherited from stk::Stk
| Stk (void)
| Default constructor.
virtual | ~Stk (void)
| Class destructor.
void | addSampleRateAlert (Stk *ptr)
| Add class pointer to list for sample rate change notification.
void | removeSampleRateAlert (Stk *ptr)
| Remove class pointer from list for sample rate change notification.
void | handleError (StkError::Type type) const
| Internal function for error reporting that assumes message in `oStream_` variable.

## Detailed Description

STK two-pole filter class.

This class implements a two-pole digital filter. A method is provided for creating a resonance in the frequency response while maintaining a nearly constant filter gain.

by Perry R. Cook and Gary P. Scavone, 1995–2021.

## Member Function Documentation

## ◆ setResonance()

void stk::TwoPole::setResonance | ( | StkFloat | frequency,
|  | StkFloat | radius,
|  | bool | normalize = `false`
| ) |  |

Sets the filter coefficients for a resonance at frequency (in Hz).

This method determines the filter coefficients corresponding to two complex-conjugate poles with the given frequency (in Hz) and radius from the z-plane origin. If normalize is true, the coefficients are then normalized to produce unity gain at frequency (the actual maximum filter gain tends to be slightly greater than unity when radius is not close to one). The resulting filter frequency response has a resonance at the given frequency. The closer the poles are to the unit-circle (radius close to one), the narrower the resulting resonance width. An unstable filter will result for radius >= 1.0. The frequency value should be between zero and half the sample rate. For a better resonance filter, use a BiQuad filter.

See also
  BiQuad filter class

## ◆ tick() [1/2]

StkFrames & stk::TwoPole::tick | ( | StkFrames & | frames,
|  | unsigned int | channel = `0`
| ) |  |
| inlinevirtual

Take a channel of the StkFrames object as inputs to the filter and replace with corresponding outputs.

The StkFrames argument reference is returned. The `channel` argument must be less than the number of channels in the StkFrames argument (the first channel is specified by 0). However, range checking is only performed if STK_DEBUG is defined during compilation, in which case an out-of-range value will trigger an StkError exception.

Implements stk::Filter.

107{
108#if defined(_STK_DEBUG_)
109 if ( channel >= frames.channels() ) {
110 oStream_ << "TwoPole::tick(): channel and StkFrames arguments are incompatible!";
111 handleError( StkError::FUNCTION_ARGUMENT );
112 }
113#endif
114
115 StkFloat *samples = &frames[channel];
116 unsigned int hop = frames.channels();
117 for ( unsigned int i=0; i<frames.frames(); i++, samples += hop ) {
118 inputs_[0] = gain_ * *samples;
119 *samples = b_[0] * inputs_[0] - a_[1] * outputs_[1] - a_[2] * outputs_[2];
120 outputs_[2] = outputs_[1];
121 outputs_[1] = *samples;
122 }
123
124 lastFrame_[0] = outputs_[1];
125 return frames;
126}
stk::Stk::handleError
static void handleError(const char *message, StkError::Type type)
Static function for error reporting and handling using c-strings.

## ◆ tick() [2/2]

StkFrames & stk::TwoPole::tick | ( | StkFrames & | iFrames,
|  | StkFrames & | oFrames,
|  | unsigned int | iChannel = `0`,
|  | unsigned int | oChannel = `0`
| ) |  |
| inline

Take a channel of the `iFrames` object as inputs to the filter and write outputs to the `oFrames` object.

The `iFrames` object reference is returned. Each channel argument must be less than the number of channels in the corresponding StkFrames argument (the first channel is specified by 0). However, range checking is only performed if STK_DEBUG is defined during compilation, in which case an out-of-range value will trigger an StkError exception.

129{
130#if defined(_STK_DEBUG_)
131 if ( iChannel >= iFrames.channels() || oChannel >= oFrames.channels() ) {
132 oStream_ << "TwoPole::tick(): channel and StkFrames arguments are incompatible!";
133 handleError( StkError::FUNCTION_ARGUMENT );
134 }
135#endif
136
137 StkFloat *iSamples = &iFrames[iChannel];
138 StkFloat *oSamples = &oFrames[oChannel];
139 unsigned int iHop = iFrames.channels(), oHop = oFrames.channels();
140 for ( unsigned int i=0; i<iFrames.frames(); i++, iSamples += iHop, oSamples += oHop ) {
141 inputs_[0] = gain_ * *iSamples;
142 *oSamples = b_[0] * inputs_[0] - a_[1] * outputs_[1] - a_[2] * outputs_[2];
143 outputs_[2] = outputs_[1];
144 outputs_[1] = *oSamples;
145 }
146
147 lastFrame_[0] = outputs_[1];
148 return iFrames;
149}

The documentation for this class was generated from the following file:

- TwoPole.h

The Synthesis ToolKit in C++ (STK)
©1995--2021 Perry R. Cook and Gary P. Scavone. All Rights Reserved.